'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var fontFamily = exports.fontFamily = '"Helvetica Neue For Number", BlinkMacSystemFont,"Segoe UI",Roboto,"PingFang SC","Hiragino Sans GB","Microsoft YaHei","Helvetica Neue",Helvetica,Arial,sans-serif"';
var backgroundTransition = exports.backgroundTransition = 'background .3s ease';
var colorTransition = exports.colorTransition = 'color .3s ease';

var footer = exports.footer = {
    borderTop: '1px solid #e9e9e9',
    boxSizing: 'border-box',
    fontSize: 12,
    position: 'relative',
    textAlign: 'right',
    padding: '9px 0',
    now: _extends({}, footerAction(), {
        position: 'absolute',
        left: 10
    }),
    mode: _extends({}, footerAction(), {
        marginRight: 10
    }),
    ok: _extends({}, footerButton(), {
        marginRight: 10
    })
};

var field = exports.field = {
    border: '1px solid #eee',
    borderWidth: '1px',
    borderRadius: '4px',
    fonSize: 12,
    boxSizing: 'border-box',
    cursor: 'auto',
    margin: 0,
    padding: 8,
    ':expanded': {
        borderWidth: '1px 1px 0 1px',
        borderRadius: '4px 4px 0 0'
    },
    input: {
        border: 'none',
        display: 'block',
        height: '20px',
        lineHeight: '20px',
        margin: 0,
        outline: 'none',
        padding: 0,
        width: '100%'
    },
    clear: {
        cursor: 'pointer',
        fontSize: 12,
        lineHeight: '20px',
        height: '20px',
        opacity: '0.5',
        position: 'absolute',
        textAlign: 'center',
        top: 8,
        right: 8,
        ':hover': {
            opacity: 1,
            color: '#666'
        }
    }
};

function footerButton() {
    return {
        backgroundColor: '#108ee9',
        border: '1px solid transparent',
        borderRadius: 4,
        boxSizing: 'border-box',
        color: '#fff',
        display: 'inline-block',
        height: '21px',
        lineHeight: '21px',
        padding: '0px 7px',
        textAlign: 'center',
        transition: backgroundTransition,
        ':hover': {
            backgroundColor: '#49a9ee'
        }
    };
}

function footerAction() {
    return {
        boxSizing: 'border-box',
        color: '#108ee9',
        cursor: 'pointer',
        display: 'inline-block',
        fontFamily: fontFamily,
        height: '21px',
        lineHeight: '21px',
        transition: colorTransition,
        WebkitFontSmoothing: 'antialiased',
        ':hover': {
            color: '#49a9ee'
        },
        ':disabled': {
            color: '#bbb'
        }
    };
}
//# sourceMappingURL=skin.js.map