'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _skin = require('../common/skin');

exports.default = {
    field: _skin.field,
    panel: {
        backgroundColor: '#fff',
        borderColor: '#e9e9e9',
        borderRadius: 3,
        borderStyle: 'solid',
        borderWidth: 1,
        boxSizing: 'border-box',
        boxShadow: '0 1px 5px #e9e9e9',
        picker: picker(),
        footer: _skin.footer
    }
};


function picker() {
    return {
        height: 168,
        header: header(),
        column: column()
    };
}

function header() {
    return {
        borderBottomColor: '#e9e9e9',
        headerBtn: {
            fontSize: '12px',
            fontWeight: 'bold',
            fontFamily: _skin.fontFamily,
            WebkitFontSmoothing: 'antialiased',
            transition: _skin.colorTransition,
            color: '#666',
            cursor: 'pointer',
            ':hover': {
                color: '#23c0fa'
            }
        }
    };
}

function column() {
    return {
        boxSizing: 'border-box',
        width: '33%',
        height: '100%',
        entry: entry(),
        ':hours': {},
        ':minutes': {
            borderLeft: '1px solid #e9e9e9',
            width: '34%'
        },
        ':seconds': {
            borderLeft: '1px solid #e9e9e9'
        }
    };
}

function entry() {
    return {
        color: '#666',
        fontFamily: _skin.fontFamily,
        fontSize: '12px',
        height: '24px',
        lineHeight: '24px',
        transition: _skin.backgroundTransition,
        WebkitFontSmoothing: 'antialiased',
        ':hover': {
            background: '#ecf6fd'
        },
        ':selected': {
            background: '#f7f7f7',
            color: 'black'
        },
        ':disabled': {}
    };
}
//# sourceMappingURL=skin.js.map